Index: squid/src/put.c
diff -u /dev/null squid/src/put.c:1.1.2.7
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/put.c	Tue Sep  3 10:41:55 2002
@@ -0,0 +1,457 @@
+/*
+ * $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * DEBUG: section 81  PUT transmission and reception
+ * AUTHOR: Jon Kay, 1997
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+
+#include "squid.h"
+
+#define PUT_REPLY_HDR()     "HTTP/1.0 200 OK\r\n"
+
+#define PUT_DELETE_GAP   (1<<18)
+
+static PF putRecvFree;
+static void putRecvError(clientHttpRequest *http,
+			 err_type error, http_status entry);
+static void putProcessHeader(HttpStateData *, clientHttpRequest *);
+static void putSendWrite(void *data, char *buf, ssize_t len);
+static CNCB putConnected;
+static CWCB putSendSent;
+
+/*
+ * Code for dealing with incoming PUT requests
+ */
+void
+putRecv(clientHttpRequest *http)
+{
+    request_t *request = http->request;
+    ConnStateData *conn = http->conn;
+    StoreEntry *entry, *oentry;
+    int lastmod, olastmod = -1;
+    HttpStateData *httpState;
+    request_flags rflags;
+    HttpReply *reply;
+    peer *p;
+    
+    http->request->flags.cachable = 1;
+    if (http->log_type != LOG_UDP_PUT)
+	http->log_type = LOG_TCP_PUT;
+    http->out.offset = 0;
+
+    oentry = storeGetPublic(http->uri, request->method);
+    if (oentry) {
+	olastmod = oentry->lastmod;
+	storeSetPrivateKey(oentry);
+    }
+    
+    /* Create private, blank entry */
+    *(unsigned int *) &rflags = 0;
+    rflags.cachable = 1;
+    entry = storeCreateEntry(http->uri, http->uri, rflags, request->method);
+
+    http->entry = entry;
+
+    /* Need a request pointer in the mem_obj */
+    requestLink(http->request);
+    entry->mem_obj->request = request;
+    
+    debug(81, 4) ("putRecv: %s for '%s'\n", log_tags[http->log_type],
+	  http->uri);
+
+    /* Update timestamp */
+    storeTimestampsSet(entry);
+
+    /* Create an HTTP context from client_side info */
+    assert(http->entry->lock_count >= 1 && http->entry->lock_count < 200);
+    httpState = httpStateFromClient(http);
+    assert(http->entry->lock_count >= 2 && http->entry->lock_count < 200);
+    httpState->entry = entry;
+    /* Prepare to reply and free httpState if PUT succeeds. */
+    comm_add_close_handler(conn->fd, putRecvFree, httpState);
+    
+    assert(http->entry->lock_count >= 2 && http->entry->lock_count < 200);
+    /* Parse the headers */
+    putProcessHeader(httpState, http);
+    reply = entry->mem_obj->reply;
+
+    /* Update the timestamp */
+    lastmod = entry->mem_obj->reply->last_modified;
+    if (lastmod > -1) {
+	if (lastmod < olastmod) {
+	    /* We do not accept old versions */
+	    ++statCounter.put.conflicts;
+	    putRecvError(http, ERR_CONFLICT, HTTP_CONFLICT);
+	    if (oentry)
+		storeSetPublicKey(oentry);
+	    /* putRecvFree will clean up on fd close */
+	    return;
+	}
+	/* Note: it's OK to overwrite the same version.  It just won't be
+	   propagated. */
+        entry->lastmod = lastmod;
+    }
+    else
+        /* Make it clear the version has changed even if no lastmod */
+        entry->lastmod = olastmod + 1;
+
+    if (oentry) {
+	/* This PUT request is good to go in.
+	 * Lose the old entry. */
+	distUpdateeChangeEntry(entry, oentry->updatees);
+	oentry->updatees = 0;
+	storeRelease(oentry);
+    }
+
+    /* Make sure dist knows about the sender, and distribute the update */
+    if (request->dist_type == DIST_DIST)
+        distNewUpdatee(entry, conn->peer.sin_addr, request->dist_port);
+    else if (request->dist_type == DIST_UNDIST)
+        distDelUpdatee(entry, conn->peer.sin_addr, request->dist_port);
+    distEntryUpdate(entry, request, &conn->peer);
+    
+    /* fwdpush support */
+    if (http->log_type == LOG_TCP_PUT) {
+        for (p = DistAllPeers; p; p = p->fwdpush) {
+#if USE_ICP_DATA
+	    if (p->options.icpdata) {
+	        putSend(entry, &p->in_addr, NULL, NULL, P_ICPDATA, p->icp_data_q);
+	    }
+	    else {
+#endif
+		struct sockaddr_in sin;
+		
+	        sin.sin_family = AF_INET;
+		sin.sin_addr = p->in_addr.sin_addr;
+		sin.sin_port = htons(p->http_port);
+		putSend(entry, &sin, NULL, NULL, 0);
+#if USE_ICP_DATA
+	    }
+#endif
+	}
+    }
+
+    /* Update stats */
+    ++statCounter.put.ins;
+
+    /* XXX - Can we use httpReplyParse to simplify this? */
+    
+    /* httpReadReply reads msgs with bodies */
+    if (entry->mem_obj->inmem_hi < reply->content_length + reply->hdr_sz) {
+	httpReadReply(conn->fd, httpState);
+    }
+    else
+	putReplyAndClose(conn->fd, entry);
+}
+
+
+/* Process PUT header. */
+static void
+putProcessHeader(HttpStateData *httpState, clientHttpRequest *client)
+{
+    static char replline[] = "HTTP/1.0 200 OK";
+    char *hdr = client->hdr_str;
+    ConnStateData *conn = client->conn;
+    int hdrlen;
+    int bodylen = conn->in.offset;  /* !yep! */
+    char *eol;
+
+    /* First change the PUT first line to a reply first line */
+    eol = strchr(hdr, '\r');
+    eol[0] = '\0';
+    strcpy(hdr, replline);
+    memset(hdr + sizeof(replline) - 1, ' ', eol - hdr - sizeof(replline) + 1);
+    eol[0] = '\r';
+
+    hdrlen = strlen(hdr);
+
+    httpProcessReplyHeader(httpState, hdr, hdrlen);
+    debug(81, 6) ("putProcessHeader: need %d bytes\n", httpState->body_remain);
+    
+    /* store header and start of data */
+    storeAppend(client->entry, hdr, hdrlen);
+    if (bodylen > 0)
+	storeAppend(client->entry, conn->in.buf, bodylen);
+    
+    httpState->body_remain -= client->entry->mem_obj->inmem_hi;
+    debug(81, 6) ("putProcessHeader: got %d bytes, %d remain\n",
+	   hdrlen + bodylen, httpState->body_remain);
+}
+
+void
+putClose(int fd, char *buf, size_t size, int errflag, void *data)
+{
+    comm_close(fd);        /* close fd and call putRecvFree */
+}
+
+void
+putReplyAndClose(int fd, StoreEntry *entry)
+{
+    storeComplete(entry);
+    
+    /* PUT succeeded, acknowledge this. */
+    if (entry->mem_obj->reply->sline.status == 200) {
+	debug(81, 6) ("putReplyAndClose: replying on %d\n", fd);
+	comm_write(fd, PUT_REPLY_HDR(), sizeof(PUT_REPLY_HDR()),
+		   putClose, 0, 0);
+    }
+    else {
+	/* Already aborted, hopefully with error msg */
+	debug(81, 2) ("putReplyAndClose: not replying - code = %d\n",
+	       entry->mem_obj->reply->sline.status);
+	comm_close(fd);        /* close fd and call putRecvFree */
+    }
+}
+
+static void
+putRecvFree(int fd, void *data)
+{
+    HttpStateData *httpState = data;
+    StoreEntry *entry = httpState->entry;
+
+    kb_incr(&statCounter.put.kbytes_in, entry->mem_obj->inmem_hi);
+    
+    httpStateFree(fd, httpState);
+    assert(entry->lock_count >= 1);
+    /* Last unlock will be from httpRequestFree */
+}
+
+static void
+putRecvError(clientHttpRequest *http,
+	     err_type error, http_status status)
+{
+    ErrorState *err;
+    
+    http->log_type = LOG_TCP_DENIED;
+    err = errorCon(error, status);
+    err->request = requestLink(http->request);
+    err->src_addr = http->conn->peer.sin_addr;
+    http->entry = clientCreateStoreEntry(http, http->request->method, null_request_flags);
+    errorAppendEntry(http->entry, err);
+}
+
+
+/* Output PUTs */
+
+/*
+ * Make up and send a PUT to a given location.
+ *
+ * The sockaddr_in does not have to persist when
+ * the call completes.
+ */
+Pusher *
+putSend(StoreEntry *entry, struct sockaddr_in *saddr,
+	PF *handler, void *arg, int dodist)
+{
+    struct in_addr nobody;
+    Pusher *p;
+    int fd;
+
+    /* Allocate memory for buffer and state tracking */
+    storeLockObject(entry);   /* Yes, we need this, even on top of StoreClient. */
+    p = cbdataAlloc(Pusher);
+    p->hdr.sc = storeClientListAdd(entry, p); 
+    p->hdr.flags.disting = dodist;
+    p->hdr.flags.active = 1;
+    p->hdr.off = 0;
+    p->hdr.objlen = 0;
+    p->hdr.entry = entry;
+    p->hdr.handler = handler;
+    p->hdr.arg = arg;
+#if USE_ICP_DATA
+    if (flags & P_ICPDATA) {
+	p->hdr.fd = comm_virtual_fd();
+	p->hdr.q = q;
+	q->dst = *saddr;
+	icpSendData(p->hdr.fd, entry, p);
+	return(p);
+    }
+    else
+	p->hdr.q = 0;
+#endif
+
+    /* Need to create and connect a PUT socket */
+    nobody.s_addr = INADDR_ANY;
+    p->hdr.fd = fd = comm_open(SOCK_STREAM, 0, nobody, 0, COMM_NONBLOCKING, "put");
+    if (fd == COMM_ERROR) {
+	debug(11, 1) ("putSend: Could not create new socket.\n");
+	putSendDone(-1, p);
+	return(0);
+    }
+    
+    /* Deal with socket closing */
+    comm_add_close_handler(fd, putSendDone, p);
+    
+    ++statCounter.put.outs;
+
+    /* Connect to this updatee */
+    strcpy(p->hdr.hname, inet_ntoa(saddr->sin_addr));
+    commConnectStart(fd, p->hdr.hname, ntohs(saddr->sin_port),
+		     putConnected, p);
+
+    return(p);
+}
+
+/* Update given updatee on contents of entry */
+static void
+putConnected(int fd, int commstat, void *data)
+{
+    Pusher *p = (Pusher *) data;
+    StoreEntry *entry = p->hdr.entry;
+    char *url;
+    
+    if (commstat == COMM_ERROR) {
+	/* XXX - this should be more sophisticated */
+	debug(11, 1) ("putConnected: Could not connect to %s\n", p->hdr.hname);
+	putSendDone(fd, p);
+	return;
+    }
+    
+    /* Figure out what URL to use */
+    url = entry->mem_obj->url;
+    if (p->hdr.flags.disting) {
+	url = distifyUrl(url);
+    }
+    
+    /* Compose header */
+    snprintf(p->data, sizeof(p->data), "PUT %s HTTP/1.0\r\n", url);
+    p->hdr.off = -strlen(p->data);
+    
+    /* Write object asynchronously, starting with header */
+    comm_write(fd, p->data, strlen(p->data), putSendSent, p, 0);
+}
+
+/* Xfer data from mem_obj to updatee */
+/* XXX - duplication with icpSendMoreData, etc. */
+static void
+putSendSent(int fd, char *obuf, size_t size, int errflag, void *data)
+{
+    Pusher *p = (Pusher *) data;
+    StoreEntry *entry = p->hdr.entry;
+    
+    debug(53, 5) ("putSendSent: FD %d '%s'\n", fd, entry->mem_obj->url);
+
+    if (errflag) {
+	debug(53, 3) ("putSendSent: write failed, errno %d\n", errno);
+	putSendDone(fd, p);
+	return;
+    }
+    
+    p->hdr.off += size;
+    
+    if (p->hdr.off >= entry->mem_obj->inmem_hi) {
+	/* We've sent everything we've seen so far */
+	if (entry->mem_obj->object_sz == entry->mem_obj->inmem_hi) {
+	    /* We've seen all we're gonna see of this version */
+	    /* note: object_len == inmem_hi iff storeComplete been called */
+	    putSendDone(fd, p);
+	    return;
+	}
+    }
+
+    storeClientCopy(p->hdr.sc, entry, p->hdr.off, 
+		    sizeof(p->data) - p->hdr.off,
+		    p->data, putSendWrite, p);
+}
+
+/* xlate storeClientCopy calling conventions to comm_write ones */
+static void
+putSendWrite(void *data, char *buf, ssize_t len)
+{
+    Pusher *p = (Pusher *) data;
+    int skipped;
+    char *tbuf;
+    
+    /*
+     * Skip over the first line, if this is the first call to putSendSent
+     * and that first line starts with HTTP/1.x.  That would be the first
+     * line in a server reply, and is incorrect in a PUT request.
+     */
+    if (p->hdr.off == 0) {
+        tbuf = strchr(p->data, '\n');
+	if (!tbuf)
+	    /* Malformatted or not enough data present yet.
+	     * Either way, don't propagate this message. */
+	    return;
+	
+	while (*++tbuf == '\r')
+	    ;
+	skipped = tbuf - p->data;
+	p->hdr.off += skipped;
+	len -= skipped;
+	buf += skipped;
+    }
+    else
+	tbuf = p->data;
+  
+    /* Do the work. */
+    comm_write(p->hdr.fd, buf, len, putSendSent, p, 0);
+}
+
+/* Send the object's data */
+void
+putSendDone(int fd, void *data)
+{
+    Pusher *p = data;
+    StoreEntry *entry = p->hdr.entry;
+
+    if (!(p->hdr.flags.active))
+	return;
+    p->hdr.flags.active = 0;
+
+    if (p->hdr.handler)
+	(*p->hdr.handler)(fd, p->hdr.arg);	
+    
+    kb_incr(&statCounter.put.kbytes_out, p->hdr.off);
+    storeUnregister(p->hdr.sc, entry, (void *) fd);
+    storeUnlockObject(entry);
+    
+    /* Free 8k buffer and pusher state along with it */
+    cbdataFree(p);
+
+    /* Don't close if ICP - ICP sends via theIcpOutConnection,
+     * which we cannot afford to close. */
+    if (fd != -1)
+	comm_close(fd);
+}
+
+
+/* Report on push stats */
+void
+statPutPrint(StoreEntry * sentry)
+{
+    storeAppendPrintf(sentry, "PUT Statistics:\n\n");
+    storeAppendPrintf(sentry, "PUTs Sent: %d\n",
+		      statCounter.put.outs);
+    storeAppendPrintf(sentry, "PUT KBytes Sent: %d\n",
+		      (int) statCounter.put.kbytes_out.kb);
+    storeAppendPrintf(sentry, "PUTs Received: %d\n", 
+		      statCounter.put.ins);
+    storeAppendPrintf(sentry, "PUT KBytes Received: %d\n", 
+		      (int) statCounter.put.kbytes_in.kb);
+    storeAppendPrintf(sentry, "Stale Objects Received: %d\n", 
+		      statCounter.put.conflicts);
+}
Index: squid/src/squid.h
diff -u squid/src/squid.h:1.19 squid/src/squid.h:1.13.2.3
--- squid/src/squid.h:1.19	Sun Sep  1 09:30:42 2002
+++ squid/src/squid.h	Tue Sep  3 10:41:56 2002
@@ -410,6 +410,10 @@
 #include "snprintf.h"
 #endif
 
+#if HAVE_SYS_MMAN_H
+#include <sys/mman.h>
+#endif
+
 #define XMIN(x,y) ((x)<(y)? (x) : (y))
 #define XMAX(a,b) ((a)>(b)? (a) : (b))
 
Index: squid/src/stat.c
diff -u squid/src/stat.c:1.17 squid/src/stat.c:1.13.2.4
--- squid/src/stat.c:1.17	Sun Apr  7 17:38:18 2002
+++ squid/src/stat.c	Tue Sep  3 10:41:57 2002
@@ -816,6 +816,32 @@
     storeAppendPrintf(sentry, "aborted_requests = %f/sec\n",
 	XAVG(aborted_requests));
 
+    storeAppendPrintf(sentry, "dist.dists = %f/sec\n",
+		      XAVG(dist.dists));
+    storeAppendPrintf(sentry, "dist.undists = %f/sec\n", 
+		      XAVG(dist.undists));
+    storeAppendPrintf(sentry, "dist.updates = %f/sec\n", 
+		      XAVG(dist.updates));
+    storeAppendPrintf(sentry, "dist.update_kbytes = %f/sec\n", 
+		      XAVG(dist.update_kbytes.kb));
+    storeAppendPrintf(sentry, "dist.content_upd = %f/sec\n",
+		      XAVG(dist.content_upd));
+    storeAppendPrintf(sentry, "dist.updatees = %f/sec\n", 
+		      XAVG(dist.updatees));
+    storeAppendPrintf(sentry, "dist.updatees = %f/sec\n",
+		      XAVG(dist.updatees * sizeof(Updatee)));
+    
+    storeAppendPrintf(sentry, "put.outs = %f/sec\n",
+		      XAVG(put.outs));
+    storeAppendPrintf(sentry, "put.kbytes_out = %f/sec\n",
+		      XAVG(put.kbytes_out.kb));
+    storeAppendPrintf(sentry, "put.ins =: %f\n", 
+		      XAVG(put.ins));
+    storeAppendPrintf(sentry, "put.kbytes_in = %f/sec\n", 
+		      XAVG(put.kbytes_in.kb));
+    storeAppendPrintf(sentry, "put.conflicts = %f/sec\n", 
+		      XAVG(put.conflicts));
+
 #if USE_POLL
     storeAppendPrintf(sentry, "syscalls.polls = %f/sec\n", XAVG(syscalls.polls));
 #endif
@@ -1200,6 +1226,32 @@
 	f->swap.files_cleaned);
     storeAppendPrintf(sentry, "aborted_requests = %d\n",
 	f->aborted_requests);
+    
+    storeAppendPrintf(sentry, "dist.dists = %d\n",
+		      f->dist.dists);
+    storeAppendPrintf(sentry, "dist.undists = %d\n", 
+		      f->dist.undists);
+    storeAppendPrintf(sentry, "dist.updates = %d\n", 
+		      f->dist.updates);
+    storeAppendPrintf(sentry, "dist.update_kbytes = %d\n", 
+		      (int) f->dist.update_kbytes.kb);
+    storeAppendPrintf(sentry, "dist.content_upd = %d\n",
+		      f->dist.content_upd);
+    storeAppendPrintf(sentry, "dist.updatees = %d\n", 
+		      f->dist.updatees);
+    storeAppendPrintf(sentry, "dist.updatees = %d\n",
+		      f->dist.updatees * sizeof(Updatee));
+    
+    storeAppendPrintf(sentry, "put.outs = %d\n",
+		      f->put.outs);
+    storeAppendPrintf(sentry, "put.kbytes_out = %d\n",
+		      (int) f->put.kbytes_out.kb);
+    storeAppendPrintf(sentry, "put.ins =: %d\n", 
+		      f->put.ins);
+    storeAppendPrintf(sentry, "put.kbytes_in = %d\n", 
+		      (int) f->put.kbytes_in.kb);
+    storeAppendPrintf(sentry, "put.conflicts = %d\n", 
+		      f->put.conflicts);
 }
 
 void
Index: squid/src/store.c
diff -u squid/src/store.c:1.17 squid/src/store.c:1.16.2.3
--- squid/src/store.c:1.17	Thu Aug 15 11:14:04 2002
+++ squid/src/store.c	Tue Sep  3 10:41:57 2002
@@ -179,6 +179,8 @@
     if (e->mem_obj)
 	destroy_MemObject(e);
     storeHashDelete(e);
+    if (e->updatees)
+	distDelUpdatees(e->updatees);
     assert(e->hash.key == NULL);
     memFree(e, MEM_STOREENTRY);
 }
@@ -192,12 +194,22 @@
 	e, storeKeyText(key));
     e->hash.key = storeKeyDup(key);
     hash_join(store_table, &e->hash);
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE()) {
+	e->hchhash.key = e->hash.key;
+	hash_join(cache_table, &e->hchash);
+    }
+#endif
 }
 
 static void
 storeHashDelete(StoreEntry * e)
 {
     hash_remove_link(store_table, &e->hash);
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE())
+	hash_remove_link(hint_table, &e->hchash);
+#endif
     storeKeyFree(e->hash.key);
     e->hash.key = NULL;
 }
@@ -710,6 +722,9 @@
 	assert(e->mem_obj->nclients == 0);
 	return;
     }
+#if USE_HINT_CACHE
+    hintCacheInformLocalCopy(e->mem_obj->url, e);
+#endif
     e->mem_obj->object_sz = e->mem_obj->inmem_hi;
     e->store_status = STORE_OK;
     assert(e->mem_status == NOT_IN_MEMORY);
@@ -873,6 +888,11 @@
 	    destroy_StoreEntry(e);
 	}
     }
+
+#if USE_HINT_CACHE
+    hintCacheInvalLocalCopy(e);
+#endif
+    
     storeLog(STORE_LOG_RELEASE, e);
     if (e->swap_filen > -1) {
 	storeUnlink(e);
@@ -1000,6 +1020,20 @@
     storeInitHashValues();
     store_table = hash_create(storeKeyHashCmp,
 	store_hash_buckets, storeKeyHashHash);
+#if USE_HINT_CACHE
+    /*
+     * Need to be able to look up objects from hint
+     * cache key so we can invalidate obsolete objects
+     * based on hint cache updates.
+     * Note: the hint cache key is just the first 8 bytes
+     * of the 16-byte cache key, so storeKeyHashHash will
+     * always work.  Although, right now, sKHH only looks
+     * at the first 32 bits anyway, giving double protection.
+     */
+    if (HINT_CACHE_ACTIVE()) 
+	hint_table = hash_create(hintCacheURLKeyCompare,
+		 store_hash_buckets, storeKeyHashHash);
+#endif
     mem_policy = createRemovalPolicy(Config.memPolicy);
     storeDigestInit();
     storeLogOpen();
@@ -1056,6 +1090,12 @@
     if (store_digest)
 	cacheDigestDestroy(store_digest);
 #endif
+#if USE_HINT_CACHE
+    if (HINT_CACHE_ACTIVE()) {
+	hashFreeMemory(hint_table);
+	hint_table = NULL;
+    }
+#endif
     store_digest = NULL;
 }
 
Index: squid/src/store_key_md5.c
diff -u squid/src/store_key_md5.c:1.6 squid/src/store_key_md5.c:1.6.24.1
--- squid/src/store_key_md5.c:1.6	Fri Apr 13 17:31:02 2001
+++ squid/src/store_key_md5.c	Fri Dec 14 00:00:37 2001
@@ -99,6 +99,11 @@
     assert(id > 0);
     debug(20, 3) ("storeKeyPrivate: %s %s\n",
 	RequestMethodStr[method], url);
+
+    /* PUT goes to same namespace as GETs do, so treat them alike here */
+    if (method == METHOD_PUT)
+	method = METHOD_GET;
+    
     MD5Init(&M);
     MD5Update(&M, (unsigned char *) &id, sizeof(id));
     MD5Update(&M, (unsigned char *) &method, sizeof(method));
@@ -113,6 +118,11 @@
     static cache_key digest[MD5_DIGEST_CHARS];
     unsigned char m = (unsigned char) method;
     MD5_CTX M;
+
+    /* PUT goes to same namespace as GETs do, so treat them alike here */
+    if (m == METHOD_PUT)
+	m = METHOD_GET;
+    
     MD5Init(&M);
     MD5Update(&M, &m, sizeof(m));
     MD5Update(&M, (unsigned char *) url, strlen(url));
@@ -133,6 +143,11 @@
     unsigned char m = (unsigned char) method;
     const char *url = urlCanonical(request);
     MD5_CTX M;
+
+    /* PUT goes to same namespace as GETs do, so treat them alike here */
+    if (m == METHOD_PUT)
+	m = METHOD_GET;
+
     MD5Init(&M);
     MD5Update(&M, &m, sizeof(m));
     MD5Update(&M, (unsigned char *) url, strlen(url));
Index: squid/src/structs.h
diff -u squid/src/structs.h:1.65 squid/src/structs.h:1.47.2.7
--- squid/src/structs.h:1.65	Sun Sep  1 09:30:42 2002
+++ squid/src/structs.h	Tue Sep  3 10:41:58 2002
@@ -338,6 +338,12 @@
 
 #endif
 
+#if USE_HINT_CACHE
+struct _URLKey {
+  HintCacheKey key;
+};
+#endif
+
 #if DELAY_POOLS
 struct _delaySpec {
     int restore_bps;
@@ -588,6 +594,11 @@
 	int ie_refresh;
 	int vary_ignore_expire;
 	int pipeline_prefetch;
+#if USE_HINT_CACHE
+	int hint_cache_listen;
+	int hint_cache_advertise;
+	int hint_cache_use_mmap;
+#endif
 	int check_hostnames;
 	int via;
     } onoff;
@@ -681,6 +692,16 @@
 	int unclean_shutdown;
     } SSL;
 #endif
+#if USE_HINT_CACHE
+    struct {
+        char *cache_file;
+        int size;
+        int assoc;
+        int intvl;
+        int join_intvl;
+        int holddown;
+    } Hints;
+#endif
     wordlist *ext_methods;
     struct {
 	int high_rptm;
@@ -979,6 +1000,7 @@
     int fd;
     http_state_flags flags;
     FwdState *fwd;
+    int body_remain;
 };
 
 struct _icpUdpData {
@@ -1062,6 +1084,7 @@
     } out;
     HttpHdrRangeIter range_iter;	/* data for iterating thru range specs */
     size_t req_sz;		/* raw request size on input, not current request size */
+    char *hdr_str;              /* Copy of headers */
     StoreEntry *entry;
     StoreEntry *old_entry;
     log_type log_type;
@@ -1281,6 +1304,13 @@
 	unsigned int no_delay:1;
 #endif
 	unsigned int allow_miss:1;
+	unsigned int dist:1;
+#if USE_ICP_DATA
+	unsigned int icpdata:1;
+#endif
+#if USE_HINT_CACHE
+	unsigned int nohint:1;
+#endif	
 #if USE_CARP
 	unsigned int carp:1;
 #endif
@@ -1319,6 +1349,8 @@
     char *login;		/* Proxy authorization */
     time_t connect_timeout;
     int max_conn;
+    peer *fwdpush;      /* next peer on FwdPushLinks */
+    int max_rate;       /* Max push rate to this peer */
 };
 
 struct _net_db_name {
@@ -1547,6 +1579,10 @@
     ping_status_t ping_status:3;
     store_status_t store_status:3;
     swap_status_t swap_status:3;
+    Updatee *updatees;
+#if USE_HINT_CACHE
+    hash_link hchash;
+#endif
 };
 
 struct _SwapDir {
@@ -1623,6 +1659,7 @@
     unsigned int accelerated:1;
     unsigned int internal:1;
     unsigned int body_sent:1;
+    unsigned int distify:1;       /* Use dist reqs for consistency */
     unsigned int reset_tcp:1;
 };
 
@@ -1672,6 +1709,8 @@
     struct in_addr client_addr;
     struct in_addr my_addr;
     unsigned short my_port;
+    int dist_type;
+    unsigned short dist_port;
     HttpHeader header;
     ConnStateData *body_connection;	/* used by clientReadBody() */
     int content_length;
@@ -1870,6 +1909,21 @@
 	int outs;
 	int ins;
     } swap;
+    struct {
+        int dists;
+	int undists;
+	int updates;
+	kb_t update_kbytes;
+	int content_upd;
+	int updatees;
+    } dist;
+    struct {
+        int outs;
+	int ins;
+	kb_t kbytes_out;
+	kb_t kbytes_in;
+	int conflicts;
+    } put;
 };
 
 /* per header statistics */
@@ -2159,10 +2213,149 @@
     } flags;
 };
 
+
+
+/*
+ * Putting state.
+ */
+struct _PushHeader {
+    int fd;
+    store_client *sc;
+    struct {
+        unsigned int active:1;
+        unsigned int dead:1;
+        unsigned int disting:1;
+#ifdef USE_ICP_DATA
+        unsigned int icpdata:1;
+#endif
+    } flags;
+    int off;
+    int objlen;
+    StoreEntry *entry;
+    PF *handler;
+    void *arg;
+#ifdef USE_ICP_DATA
+    icpQueue *q;
+#endif
+    unsigned reqnum; /* ICP reqnum */
+    char hname[20];
+};
+
+struct _Pusher {
+    PushHeader hdr;
+    char data[16384 - sizeof(PushHeader)];
+};
+
 struct cache_dir_option {
     const char *name;
     void (*parse) (SwapDir * sd, const char *option, const char *value, int reconfiguring);
     void (*dump) (StoreEntry * e, const char *option, SwapDir * sd);
 };
 
+
+/* Tracking state for update ("push") requester */
+struct _updatee {
+    struct _updatee *next;
+    StoreEntry *entry;         /* Backpointer to relevant entry */
+    struct sockaddr_in saddr;
+    time_t lastmod;
+    Pusher *p;
+};
+
+
+#if USE_HINT_CACHE
+
+/* Hint Cache Interface */
+/*
+ * Primitive data types. All have a -Net format which has an
+ * agreed-upon endian-ness.
+ */
+
+
+struct _URLKeyNet {
+    HintCacheKey mungedKey;
+};
+
+struct _NodeKey {
+    dlink_node links;
+    HintCacheKey key;
+    struct sockaddr_in addr;
+};
+
+struct _HintCacheEntry {
+    URLKey         key;
+    struct in_addr ipaddr;
+    unsigned short port;
+    short          pad;    /* Compiler padding space */
+    unsigned int   mtime;  /* Last-modified time */
+};
+
+/* This is what goes onto the net */
+struct _HintCacheEntryNet {
+    URLKeyNet     mungedKey;
+    struct in_addr mungedIpaddr;
+    unsigned short mungedPort;
+    short          mungedPad;
+    unsigned int   mungedMtime;
+};
+
+struct _HintCacheUpdate {
+    unsigned char          action;
+    char                   hopcount;
+    char                   UNUSED;  /* Remove this field sometime XXX */
+    char                   pad1;
+    int                    pad2;
+    HintCacheEntry                entry;
+};
+
+struct _HintCacheUpdateNet {
+    unsigned char          mungedAction;
+    char                   mungedHopcount;
+    char                   mungedUNUSED; 
+    char                   mungedPad1;
+    int                    mungedPad2;
+    HintCacheEntryNet      mungedEntry;
+};
+
+/* Hint Cache Disk */
+struct _HintCacheDiskEntry {
+    HintCacheEntry      entry; 
+    unsigned int rtime; /* Time of entry receipt */
+};
+
+struct _HintCacheDisk {
+    unsigned int nbuckets;
+    int entriesPerBucket;
+    HintCacheDiskEntry *mmappedArray;
+    int fd;
+};
+
+typedef struct HintCacheNetS{
+    StoreEntry *sendBuffer;
+    int         sendLength;
+    enum HintCacheNet_State state;
+#ifdef DOTEST
+    int         testMode;
+    int         testCount;
+#endif
+} HintCacheNet;
+
+typedef struct HintCacheNetHeaderS {
+    unsigned short httpport;  /* Port of sending server */
+    unsigned short updlen;    /* Length of individual update */
+} HintCacheNetHeader;
+
+#endif /* USE_HINT_CACHE */
+
+#if USE_ICP_DATA
+typedef struct _icpDataStats {
+    int nsends;
+    int nrecvs;
+    int nfrags;
+    int ndups;
+    int ntmofrags;
+    int nbadfrags;
+} 
+#endif
+
 #endif /* SQUID_STRUCTS_H */
Index: squid/src/typedefs.h
diff -u squid/src/typedefs.h:1.27 squid/src/typedefs.h:1.25.2.6
--- squid/src/typedefs.h:1.27	Sun Jun 23 06:38:04 2002
+++ squid/src/typedefs.h	Tue Sep  3 10:42:00 2002
@@ -351,6 +351,37 @@
 
 typedef int STDIRSELECT(const StoreEntry *);
 
+/* PUT internal data structure */
+typedef struct _PushHeader PushHeader;
+typedef struct _Pusher Pusher;
+
+/* Automatic update ("push") requester */
+typedef struct _updatee Updatee;
+
+#if USE_HINT_CACHE
+/* Hint Cache Interface */
+typedef unsigned Net_unsigned;
+typedef long long unsigned Net_longlong;
+typedef unsigned long long HintCacheKey;
+typedef struct _URLKey URLKey;
+typedef struct _URLKeyNet URLKeyNet;
+typedef struct _NodeKey NodeKey;
+typedef struct _HintCacheEntry HintCacheEntry;
+typedef struct _HintCacheEntryNet HintCacheEntryNet;
+typedef struct _HintCacheUpdate HintCacheUpdate;
+typedef struct _HintCacheUpdateNet HintCacheUpdateNet;
+
+/* Hint Cache Disk */
+typedef struct _HintCacheDiskEntry HintCacheDiskEntry;
+typedef struct _HintCacheDisk HintCacheDisk;
+
+typedef dlink_node *HintCacheNodeListIter;
+#endif /* USE_HINT_CACHE */
+
+#if USE_ICP_DATA
+typedef struct _icpDataStats icpDataStats;
+#endif
+
 typedef struct _external_acl external_acl;
 typedef struct _external_acl_entry external_acl_entry;
 
Index: squid/src/url.c
diff -u squid/src/url.c:1.10 squid/src/url.c:1.7.2.3
--- squid/src/url.c:1.10	Fri Aug 23 19:06:24 2002
+++ squid/src/url.c	Tue Sep  3 10:42:01 2002
@@ -102,6 +102,9 @@
     "whois",
     "internal",
     "https",
+#if USE_HINT_CACHE
+    "route",
+#endif
     "TOTAL"
 };
 
@@ -195,30 +198,84 @@
 
 
 protocol_t
-urlParseProtocol(const char *s)
+urlParseProtocol(const char *s, u_short *dportp, int *dtypep)
 {
+    int proto;
+  
     /* test common stuff first */
-    if (strcasecmp(s, "http") == 0)
-	return PROTO_HTTP;
-    if (strcasecmp(s, "ftp") == 0)
-	return PROTO_FTP;
-    if (strcasecmp(s, "https") == 0)
-	return PROTO_HTTPS;
-    if (strcasecmp(s, "file") == 0)
-	return PROTO_FTP;
-    if (strcasecmp(s, "gopher") == 0)
-	return PROTO_GOPHER;
-    if (strcasecmp(s, "wais") == 0)
-	return PROTO_WAIS;
-    if (strcasecmp(s, "cache_object") == 0)
-	return PROTO_CACHEOBJ;
-    if (strcasecmp(s, "urn") == 0)
-	return PROTO_URN;
-    if (strcasecmp(s, "whois") == 0)
-	return PROTO_WHOIS;
-    if (strcasecmp(s, "internal") == 0)
-	return PROTO_INTERNAL;
-    return PROTO_NONE;
+    if (strncasecmp(s, "http", 4) == 0) {
+	s += 4;
+	proto = PROTO_HTTP;
+    }
+#if USE_HINT_CACHE    
+    else if (strncasecmp(s, "route", 5) == 0) {
+	s += 5;
+	proto = PROTO_ROUTE;
+    }
+#endif
+  else if (strncasecmp(s, "ftp", 3) == 0) {
+	s += 3;
+        proto = PROTO_FTP;
+    }
+    else if (strncasecmp(s, "https", 5) == 0) {
+	s += 5;
+	proto = PROTO_HTTPS;
+    }
+    else if (strncasecmp(s, "file", 4) == 0) {
+	s += 4;
+        proto = PROTO_FTP;
+    }
+    else if (strncasecmp(s, "gopher", 6) == 0) {
+	s += 6;
+	proto = PROTO_GOPHER;
+    }
+    else if (strncasecmp(s, "wais", 4) == 0) {
+	s += 4;
+	proto =PROTO_WAIS;
+    }
+    else if (strncasecmp(s, "cache_object", 12) == 0) {
+	s += 12;
+	proto = PROTO_CACHEOBJ;
+    }
+    else if (strncasecmp(s, "urn", 3) == 0) {
+	s += 3;
+	proto = PROTO_URN;
+    }
+    else if (strncasecmp(s, "whois", 5) == 0) {
+	s += 5;
+        proto = PROTO_WHOIS;
+    }
+    else if (strncasecmp(s, "internal", 8) == 0) {
+	s += 8;
+	proto = PROTO_INTERNAL;
+    }
+    else
+        proto = PROTO_NONE;
+
+    if (dportp != NULL) {
+	if (strncasecmp(s, "dist", 4) == 0) {
+	    s += 4;
+	    if (dportp != NULL)
+		*dportp = ntohs(atoi(s));
+	    if (dtypep)
+		*dtypep = DIST_DIST;
+	}
+	else if (strncasecmp(s, "undist", 6) == 0) {
+	    s += 6;
+	    if (dportp != NULL)
+		*dportp = ntohs(atoi(s));
+	    if (dtypep)
+		*dtypep = DIST_UNDIST;
+	}
+	else {
+	    if (dportp)
+		*dportp = 0;
+	    if (dtypep)
+		*dtypep = 0;
+	}
+    }
+    
+    return proto;
 }
 
 
@@ -256,7 +313,7 @@
     request_t *request = NULL;
     char *t = NULL;
     char *q = NULL;
-    int port;
+    int port, dport, dtype;
     protocol_t protocol = PROTO_NONE;
     int l;
     proto[0] = host[0] = urlpath[0] = login[0] = '\0';
@@ -276,7 +333,7 @@
     } else {
 	if (sscanf(url, "%[^:]://%[^/]%[^\r\n]", proto, host, urlpath) < 2)
 	    return NULL;
-	protocol = urlParseProtocol(proto);
+	protocol = urlParseProtocol(proto, &dport, &dtype);
 	port = urlDefaultPort(protocol);
 	/* Is there any login informaiton? */
 	if ((t = strrchr(host, '@'))) {
@@ -357,6 +414,8 @@
     xstrncpy(request->host, host, SQUIDHOSTNAMELEN);
     xstrncpy(request->login, login, MAX_LOGIN_SZ);
     request->port = (u_short) port;
+    request->dist_port = (u_short) dport;
+    request->dist_type = dtype;
     return request;
 }
 
